//----------------------------------------------------------------------------
// Borland Class Library
// Copyright (c) 1993, 2000 by Inprise Corp., All Rights Reserved
//
//$Revision:   1.5  $
//
//----------------------------------------------------------------------------
#if !defined(CLASSLIB_DEFS_H)
#include <classlib/pre.h> /* - pre-CLASSLIB - */
#define CLASSLIB_DEFS_H

#if !defined(__cplusplus)
# error Must compile Borland Class Library as C++
#endif

//----------------------------------------------------------------------------
// We must use all libraries in DLLs if we are using BIDS in a DLL
//
// Define _BIDSDLL with -WSE (-WE for 32bit) to use BIDS & RTL in dlls.
//
// Be sure _BUILDBIDSDLL is defined when building an actual BIDS dll
//
#if defined(_BIDSDLL) || defined(_CLASSDLL) || defined(_BUILDBIDSDLL) || defined(_RTLDLL)
# if !defined(_BIDSDLL)
#   define _BIDSDLL
# endif
# if !defined(_SVCSDLL)
#   define _SVCSDLL
# endif
# if !defined(_RTLDLL)
#   define _RTLDLL
# endif
#endif

//
// Get core services definitions and the windowing system headers
//
// Get core RTL definitions
//
#if defined(BI_COMP_BORLANDC)
# include <_defs.h>                   // Borland RTL core definitions
#else
//# include <services/private/defs.h>   // General purpose definitions???
#endif

// include window
#include <windows.h>

#if !defined(__TCHAR_H)
# include <tchar.h>
#endif

#if !defined(_CALLCNVN)
# define _CALLCNVN   //__stdcall
#endif

#if defined(_MSC_VER)
# define __export    __declspec(dllexport)
# define __import    __declspec(dllimport)
# define _FAR 
# define _EXPFUNC32
#define _RTLENTRY
#define _USERENTRY
# define _EXPCLASS   _CRTIMP
#endif

#if defined(_BIDSTMPLEXT)
# include <classlib/tmplext.h>
#endif

//----------------------------------------------------------------------------
//
//  To restore the old BIDS naming convention of data and function names
//  beginning with lowercase letters, in addition to the new convention of
//  uppercase letters, remove the // from the #define below or define on the
//  cmd line. The libraries do not need to be rebuilt.
//

//#define BI_OLDNAMES         // add names with initial lowercase

//----------------------------------------------------------------------------
//
//  Common definitions for pointer size and calling conventions.
//
//  Calling conventions:
//
//  _BIDSENTRY      Specifies the calling convention used by BIDS.
//
//
//  Export (and size for DOS) information:
//
//  _BIDSCLASS      Exports class if building DLL version of library.
//                  For DOS16 also provides size information.
//
//  _BIDSDATA       Exports data if building DLL version of library.
//
//  _BIDSFUNC       Exports function if building DLL version of library.
//                  For DOS16 also provides size information
//
//  _BIDSFAR        Promotes data pointers to far in DLLs (DOS16 only).
//
//  _BIDSFARDATA    Forces data pointer to be far.
//
//  _BIDSFARFUNC    Forces function to be far.
//
//  _BIDSFARCLASS   Forces class to be far.
//
//  _BIDSNEARDATA   Forces data to be near.
//
//  _BIDSNEARFUNC   Forces function to be near.
//
//  _BIDSNEARCLASS  Forces class to be near.
//
//----------------------------------------------------------------------------

#define _BIDSENTRY _CALLCNVN
#if defined(_MSC_VER)
# define _BIDSCTOR
#else
# define _BIDSCTOR _BIDSENTRY
#endif

#define _BIDSFARDATA
#define _BIDSFARFUNC
#define _BIDSFARCLASS
#define _BIDSNEARDATA
#define _BIDSNEARFUNC
#define _BIDSNEARCLASS
#if defined(_BUILDBIDSDLL)
#  define _BIDSCLASS     __export _CALLCNVN
#  define _BIDSCLASS_RTL __export _CALLCNVN
#  define _BIDSTEMPL     __export
#  define _BIDSDATA      __export
#  define _BIDSFUNC      __export
#elif defined(_BIDSDLL)
#  define _BIDSCLASS     __import _CALLCNVN
#  define _BIDSCLASS_RTL __import _CALLCNVN
#  define _BIDSTEMPL     __import
#  define _BIDSDATA      __import
#  define _BIDSFUNC      __import
#else
#  define _BIDSCLASS     _CALLCNVN
#  define _BIDSCLASS_RTL _CALLCNVN
#  define _BIDSTEMPL
#  define _BIDSDATA
#  define _BIDSFUNC
#endif
#define _BIDSFAR

#if defined(BI_NAMESPACE)

#define NS_CLASSLIB ::ClassLib

#else

#define NS_CLASSLIB

#endif // BI_NAMESPACE

#include <classlib/post.h> /* - post-CLASSLIB - */
#endif  // CLASSLIB_DEFS_H
