//----------------------------------------------------------------------------
// Borland Class Library
// Copyright (c) 1993, 2000 by Inprise Corp., All Rights Reserved
//
//$Revision:   1.4  $
//
//----------------------------------------------------------------------------
#if !defined(CLASSLIB_VOIDP_H)
#include <classlib/pre.h> /* - pre-CLASSLIB - */
# define CLASSLIB_VOIDP_H

#if !defined( CLASSLIB_DEFS_H )
# include <classlib/defs.h>
#endif

// if used with OWL
#if defined(OWL_DEFS_H)
#	include <owl/pointer.h>

inline bool operator <(const TVoidPointer& l, const TVoidPointer& r)
	{	return (char*)(void*)l < (char*)(void*)r;}

#else // defined(OWL_DEFS_H)

#if defined( BI_CLASSLIB_NO_po )
# pragma option -po-
#endif

#if defined(BI_NAMESPACE)
namespace ClassLib {
#endif

class _BIDSCLASS TVoidPointer;
inline bool operator <(const TVoidPointer& l, const TVoidPointer& r);

class _BIDSCLASS TVoidPointer{
	public:
    TVoidPointer( const void *p = 0 ) : Ptr(p) {}
    TVoidPointer( const TVoidPointer& rp ) : Ptr(rp.Ptr) {}
    const TVoidPointer& operator = ( const TVoidPointer& vp )
        { Ptr = vp.Ptr; return *this; }
    const TVoidPointer& operator = ( const void *p )
        { Ptr = p; return *this; }
    operator void *() const { return const_cast<void*>(Ptr); }

	private:
    const void *Ptr;
  friend bool operator <(const TVoidPointer& l, const TVoidPointer& r);
};

inline bool operator <(const TVoidPointer& l, const TVoidPointer& r)
	{	return (char*)l.Ptr < (char*)r.Ptr;}


#if defined(BI_NAMESPACE)
}   // namespace ClassLib
#endif

#if defined( BI_CLASSLIB_NO_po )
# pragma option -po.
#endif

#endif // defined(OWL_DEFS_H)

#include <classlib/post.h> /* - post-CLASSLIB - */
#endif  // CLASSLIB_VOIDP_H

